#include "bullet.h"

bullet bullet_create(point npos, point nspeed, float size){

    bullet b = { npos, nspeed, sprite_create(size,size), true, 0 };

    return b;

}

void bullet_render(bullet * b, ALLEGRO_BITMAP * bmp){

    if(b->exist){
        sprite_render(&b->spr,b->pos.x-b->spr.frame_w/2,b->pos.y-b->spr.frame_w/2,bmp);
    }
    else if(b->deathTimer > 0){
       al_draw_filled_circle(b->pos.x,b->pos.y,b->deathTimer,al_map_rgb(255,255,255));
    }

}

void bullet_events(bullet * b, ALLEGRO_SAMPLE * s){

    if(b->exist){

        if(b->spr.frame_w == 8)
            sprite_animate(&b->spr,0,0,3,1);
        else
            sprite_animate(&b->spr,0,0,2,1);

        b->pos.x += b->speed.x;
        b->pos.y += b->speed.y;

        b->speed.y += 0.2;

        if(b->pos.x-16 > 256 || b-> pos.x+16 < 0 || b->pos.y-4 > 240-24 || b-> pos.y+16 < 0){
            b->deathTimer = 2 + b->spr.frame_w;
            b->exist = false;
        }

    }else{

        if(b->deathTimer > 0){
            b->deathTimer--;
        }

        if(b->deathTimer == 2 + b->spr.frame_w - 1 && !(b->pos.x-16 > 256 || b-> pos.x+16 < 0 || b-> pos.y+16 < 0)){
            al_play_sample(s,1.0,0.0,1.0,ALLEGRO_PLAYMODE_ONCE,NULL);
        }
    }

}
