#ifndef __NC_BALL__
#define __NC_BALL__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}ball;

ball ball_create(point npos, float nspeed);
void ball_events(ball * l, bool reborn);
void ball_render(ball * l,ALLEGRO_BITMAP*bmp);
void ball_bulletCollision(ball * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void ball_playerCollision(ball * l, objPlayer * pl, int * lives);

#endif // __NC_BALL__
