#include "bigleaf.h"

bigleaf bigleaf_create(point npos, float nspeed){

    bigleaf l = { npos, sprite_create(24,24),0.0,nspeed,30,40,false};
    return l;

}

void bigleaf_events(bigleaf * l, nbomb * n, int * current_bomb, ALLEGRO_SAMPLE * s, bool reborn){

    if(!l->dead){

        if(n != NULL){

            if(l->bomb_timer <= 0){

                if(l->pos.x >= 0 && l->pos.x <= 256){

                    if(s != NULL)
                        al_play_sample(s,1.0,0.0,0.75,ALLEGRO_PLAYMODE_ONCE,NULL);

                    n[*current_bomb] = nbomb_create(newPoint(l->pos.x,l->pos.y+8),0);
                    *current_bomb += 1;

                    if(*current_bomb > 9){
                        *current_bomb = 0;
                    }
                }

                l->bomb_timer = 20;
            }
            else{
                l->bomb_timer--;
            }

        }

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(l->pos.y < 0){
            l->pos.y = 0;
            l->gravity = 0.0;
        }

        if(l->pos.y > 240-32){
            l->pos.y = 240-32;
            l->gravity *= -1.0;
        }

        l->gravity += 0.025;
        if(l->gravity > 2.0){
            l->gravity = -(float)(rand() % 40 + 1)/10.0;
        }

        sprite_animate(&l->spr,0,0,5,2);

    }
    else{

        l->gravity += 0.1;
        l->pos.y += l->gravity;

        sprite_animate(&l->spr,1,0,0,1);
    }

    if((l->speed > 0 && l->pos.x > 256+8) || (l->speed < 0 && l->pos.x < -8)){

        l->spr.scale_x *= -1;
        l->speed = (float)(rand() % 20 + 10)/10.0 * l->spr.scale_x;

    }

    if(l->hp <= 0 && !l->dead){
        l->gravity = 0.0;
        l->dead = true;
    }

    if(reborn && l->pos.y > 240+32 && !n){

        int r = rand() % 2 + 1;

        if(r == 2){

                l->pos = newPoint(-64 - rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = 1;
                l->dead = false;
                l->hp = 3;

        }else{

                l->pos = newPoint(320 + rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = -1;
                l->dead = false;
                l->hp = 3;
        }

    }

}

void bigleaf_render(bigleaf * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -12 && l->pos.x < 256+12){

        if(l->pos.y < 240-16){
            al_draw_filled_ellipse(l->pos.x,240-16,12 - (240-16 - l->pos.y)/100,4 - (240-16 - l->pos.y)/200,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-12,l->pos.y-12,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+12,l->pos.y-12,bmp);
        }

    }

}

void bigleaf_bulletCollision(bigleaf * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(b->pos.x+2 > l->pos.x-12 && b->pos.x-2 < l->pos.x+12 && b->pos.y+2 > l->pos.y-12 && b->pos.y-2 < l->pos.y+12 && b->exist && !l->dead){
        l->hp--;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        if(l->hp == 0){
            *score += 1000 * (*multiplier + 1);
            *multiplier += 1;
            *multiplier_timer = 60;
        }
    }

}

void bigleaf_playerCollision(bigleaf * l, objPlayer * pl, int * lives){

    if(pl->pos.x+8 > l->pos.x-12 && pl->pos.x-8 < l->pos.x+12 && pl->pos.y+8 > l->pos.y-12 && pl->pos.y-8 < l->pos.y+12 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }

}
