#ifndef __NC_BIGLEAF__
#define __NC_BIGLEAF__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"
#include "nbomb.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    int hp;

    uint8_t bomb_timer;

    bool dead;

}bigleaf;

bigleaf bigleaf_create(point npos, float nspeed);
void bigleaf_events(bigleaf * l, nbomb n[], int * current_bomb, ALLEGRO_SAMPLE * s, bool reborn);
void bigleaf_render(bigleaf * l,ALLEGRO_BITMAP*bmp);
void bigleaf_bulletCollision(bigleaf * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void bigleaf_playerCollision(bigleaf * l, objPlayer * pl, int * lives);

#endif // __NC_BIGLEAF__
