#include "bigorb.h"

bigorb bigorb_create(point npos, float nspeed){

    bigorb l = { npos, sprite_create(32,32),0.0,nspeed,60,false};
    return l;

}

void bigorb_events(bigorb * l,bool reborn, orb * orbs, int * current_orb){

    int i;

    if(!l->dead){

        if(l->speed > 0 && l->pos.x > 256){
            l->speed = -(float)(rand() % 40+ 20)/10;
        }

        if(l->speed < 0 && l->pos.x < 0){
            l->speed = (float)(rand() % 40 + 20)/10;
        }

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(l->speed > 0){
            l->spr.scale_x = 1;
        }
        else{
            l->spr.scale_x = -1;
        }

        l->gravity += 0.25;

        if(l->pos.y > 240-32){

            l->pos.y = 240-32;
            l->gravity = -(float)(rand() % 600 + 400)/100.0;

            if(orbs){

            if(l->pos.x >= 0 && l->pos.x <= 256){

                    for(i = 0; i < 10; i++){

                        if(orbs[*current_orb].dead){

                            orbs[*current_orb] = orb_create(newPoint(l->pos.x,l->pos.y+8),(float)(rand() % 400 + 200)/100.0 - 2.0);
                            break;

                        }

                    }

                    *current_orb += 1;

                    if(*current_orb > 9){
                        *current_orb = 0;
                    }

                }

            }

        }

        sprite_animate(&l->spr,0,0,3,2);

    }
    else{

        l->gravity += 0.25;
        l->pos.y += l->gravity;

        sprite_animate(&l->spr,1,0,0,1);
    }

    if(l->hp <= 0 && !l->dead){
        l->gravity = 0.0;
        l->dead = true;
    }

    if(reborn && l->pos.y > 240+32 && !orbs){

        int r = rand() % 2 + 1;

        if(r == 2){

                l->pos = newPoint(-64 - rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = 1;
                l->dead = false;
                l->hp = 3;

        }else{

                l->pos = newPoint(320 + rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = -1;
                l->dead = false;
                l->hp = 3;
        }

    }

}

void bigorb_render(bigorb * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -8 && l->pos.x < 256+8){

        if(l->pos.y < 240-16){
            al_draw_filled_ellipse(l->pos.x,240-16,16 - (240-16 - l->pos.y)/75,6 - (240-16 - l->pos.y)/150,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-16,l->pos.y-16,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+16,l->pos.y-16,bmp);
        }

    }

}

void bigorb_bulletCollision(bigorb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(sqrt(pow(b->pos.x - l->pos.x,2) + pow(b->pos.y - l->pos.y,2)) < 32 && b->exist && !l->dead){
        l->hp--;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        if(l->hp == 0){
            *score += 2000 * (*multiplier + 1);
            *multiplier += 1;
            *multiplier_timer = 60;
        }
    }

}

void bigorb_playerCollision(bigorb * l, objPlayer * pl, int * lives){

    if(pl->pos.x+4 > l->pos.x-16 && pl->pos.x-4 < l->pos.x+16 && pl->pos.y+4 > l->pos.y-16 && pl->pos.y-4 < l->pos.y+16 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }
}

