#ifndef __NC_BIGORB__
#define __NC_BIGORB__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"
#include "orb.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    int8_t hp;

    bool dead;

}bigorb;

bigorb bigorb_create(point npos, float nspeed);
void bigorb_events(bigorb * l, bool reborn, orb * orbs, int * current_orb);
void bigorb_render(bigorb * l,ALLEGRO_BITMAP*bmp);
void bigorb_bulletCollision(bigorb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void bigorb_playerCollision(bigorb * l, objPlayer * pl, int * lives);

#endif // __NC_BIGORB__
