#include "bulletb.h"

bulletb bulletb_create(point npos, float nspeed){

    bulletb l = { npos, sprite_create(16,16),(float)(rand() % 30 + 10)/10,nspeed,false};
    return l;

}

void bulletb_events(bulletb * l,bool reborn){

    if(!l->dead){

        if(l->pos.y > 240-24 && l->gravity >= 0.0){
            l->pos.y = 240-24;
            l->gravity = -(float)(rand() % 30 + 10)/10;
        }
        else if(l->pos.y < 16 && l->gravity < 0.0){
            l->pos.y = 16;
            l->gravity = (float)(rand() % 30 + 10)/10;
        }

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(l->gravity >= 0.0){
            sprite_animate(&l->spr,0,0,3,1);
        }
        else{
            sprite_animate(&l->spr,1,0,3,1);
        }

    }
    else{

        l->gravity += 0.25;
        l->pos.y += l->gravity;

        sprite_animate(&l->spr,2,0,0,1);

        if(reborn && l->pos.y > 240+8){

           l->pos = newPoint(8 + rand() % 256 - 16,- (rand() % 640 + 160));
            l->speed = 0;
            l->gravity = (float)(rand() % 30 + 10)/10;
            l->spr.scale_x = 1;
            l->dead = false;
            l->spr.currentFrame = 0;

        }

    }

}

void bulletb_render(bulletb * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -8 && l->pos.x < 256+8 ){

        if(l->pos.y < 240-16 && !(l->dead && l->spr.currentFrame == 5) && l->pos.y > -16){
            al_draw_filled_ellipse(l->pos.x,240-16,8 - (240-16 - l->pos.y)/75,3 - (240-16 - l->pos.y)/150,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-8,l->pos.y-8,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+8,l->pos.y-8,bmp);
        }

    }

}

void bulletb_bulletCollision(bulletb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(b->pos.x+2 > l->pos.x-8 && b->pos.x-2 < l->pos.x+8 && b->pos.y+2 > l->pos.y-8 && b->pos.y-2 < l->pos.y+8 && b->exist && !l->dead){
        l->gravity = 0.0;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        l->dead = true;
        l->spr.currentFrame = 0;
        *score += 450 * (*multiplier + 1);
        *multiplier += 1;
        *multiplier_timer = 60;
    }

}

void bulletb_playerCollision(bulletb * l, objPlayer * pl, int * lives){

    if(pl->pos.x+4 > l->pos.x-8 && pl->pos.x-4 < l->pos.x+8 && pl->pos.y+4 > l->pos.y-8 && pl->pos.y-4 < l->pos.y+8 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }
}
