#ifndef __NC_BULLETB__
#define __NC_BULLETB__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}bulletb;

bulletb bulletb_create(point npos, float nspeed);
void bulletb_events(bulletb * l, bool reborn);
void bulletb_render(bulletb * l,ALLEGRO_BITMAP*bmp);
void bulletb_bulletCollision(bulletb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void bulletb_playerCollision(bulletb * l, objPlayer * pl, int * lives);

#endif // __NC_BULLETB__
