#ifndef __NC_FLAME__
#define __NC_FLAME__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}flame;

flame flame_create(point npos, float nspeed);
void flame_events(flame * l, bool reborn);
void flame_render(flame * l,ALLEGRO_BITMAP*bmp);
void flame_bulletCollision(flame * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void flame_playerCollision(flame * l, objPlayer * pl, int * lives);

#endif // __NC_FLAME__
