#ifndef __NC_FLAME2__
#define __NC_FLAME2__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}flame2;

flame2 flame2_create(point npos, float nspeed);
void flame2_events(flame2 * l, bool reborn);
void flame2_render(flame2 * l,ALLEGRO_BITMAP*bmp);
void flame2_bulletCollision(flame2 * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void flame2_playerCollision(flame2 * l, objPlayer * pl, int * lives);

#endif // __NC_FLAME2__
