#include "flyguy.h"

flyguy flyguy_create(point npos, float nspeed){

    flyguy l = { npos, sprite_create(32,32),(float)(rand() % 30 + 10)/10,nspeed,75,0,false};
    return l;

}

void flyguy_events(flyguy * l, flame2 * flame2s, int * current_flame2, bool reborn){

    int i;

    if(!l->dead){

        if(l->speed > 0){
            l->spr.scale_x = 1;
        }
        else{
            l->spr.scale_x = -1;
        }

        if(l->pos.y > 240-32 && l->gravity >= 0.0){
            l->pos.y = 240-32;
            l->gravity = -(float)(rand() % 40 + 15)/10;
        }
        else if(l->pos.y < 16 && l->gravity < 0.0){
            l->pos.y = 16;
            l->gravity = (float)(rand() % 40 + 15)/10;
        }

        if(l->pos.x < 0 && l->speed < 0){
            l->pos.x = 0;
            l->speed = (float)(rand() % 40 + 5)/10.0;
        }

        if(l->pos.x > 255 && l->speed > 0){
            l->pos.x = 255;
            l->speed = -(float)(rand() % 40 + 5)/10.0;
        }

        if(l->spr.currentFrame == 11 && l->spr.changeFrameCount == 0 && l->pos.y > -16 && flame2s){

            flame2s[*current_flame2] = flame2_create(newPoint(l->pos.x,l->pos.y),l->speed * 2.0);
            flame2s[*current_flame2].spr.scale_x = l->spr.scale_x;
            flame2s[*current_flame2].dead = false;

            *current_flame2 += 1;

            if(*current_flame2 > 9){
                *current_flame2 = 0;
            }

        }

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(flame2s){
            sprite_animate(&l->spr,0,0,15,0);
        }
        else{
            sprite_animate(&l->spr,0,0,7,0);
        }

    }
    else{

        l->gravity += 0.25;
        l->pos.y += l->gravity;

        sprite_animate(&l->spr,1,0,0,1);
    }

    if(l->hp <= 0 && !l->dead){
        l->gravity = 0.0;
        l->dead = true;
    }

    if(reborn && l->pos.y > 240+32 && !flame2s){

        int r = rand() % 2 + 1;

        if(r == 2){

                l->pos = newPoint(-96 - rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = (float)(rand() % 2000)/1000 - 1.0;
                l->spr.scale_x = 1;
                l->dead = false;
                l->hp = 3;

        }else{

                l->pos = newPoint(360 + rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2000 + 1000)/1000;
                l->gravity = (float)(rand() % 2000)/1000 - 1.0;
                l->spr.scale_x = -1;
                l->dead = false;
                l->hp = 3;
        }

    }

}

void flyguy_render(flyguy * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -8 && l->pos.x < 256+8 ){

        if(l->pos.y < 240-16 && !(l->dead && l->spr.currentFrame == 5) && l->pos.y > -16){
            al_draw_filled_ellipse(l->pos.x,240-16,16 - (240-16 - l->pos.y)/75,4 - (240-16 - l->pos.y)/150,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-16,l->pos.y-16,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+16,l->pos.y-16,bmp);
        }

    }

}

void flyguy_bulletCollision(flyguy * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(b->pos.x+2 > l->pos.x-16 && b->pos.x-2 < l->pos.x+16 && b->pos.y+2 > l->pos.y-16 && b->pos.y-2 < l->pos.y+16 && b->exist && !l->dead){
        l->hp--;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        if(l->hp == 0){
            *score += 3000 * (*multiplier + 1);
            *multiplier += 1;
            *multiplier_timer = 60;
        }
    }

}

void flyguy_playerCollision(flyguy * l, objPlayer * pl, int * lives){

    if(pl->pos.x+4 > l->pos.x-16 && pl->pos.x-4 < l->pos.x+16 && pl->pos.y+4 > l->pos.y-16 && pl->pos.y-4 < l->pos.y+16 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }
}

