#ifndef __NC_FLYGUY__
#define __NC_FLYGUY__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"
#include "flame2.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    int hp;

    uint8_t flame_timer;

    bool dead;

}flyguy;

flyguy flyguy_create(point npos, float nspeed);
void flyguy_events(flyguy * l ,  flame2 * flame2s, int * current_flame2, bool reborn);
void flyguy_render(flyguy * l,ALLEGRO_BITMAP*bmp);
void flyguy_bulletCollision(flyguy * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void flyguy_playerCollision(flyguy * l, objPlayer * pl, int * lives);

#endif // __NC_FLYGUY__
