#ifndef __NC_LEAF__
#define __NC_LEAF__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}leaf;

leaf leaf_create(point npos, float nspeed);
void leaf_events(leaf * l, bool reborn);
void leaf_render(leaf * l,ALLEGRO_BITMAP*bmp);
void leaf_bulletCollision(leaf * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void leaf_playerCollision(leaf * l, objPlayer * pl, int * lives);

#endif // __NC_LEAF__
