#include "nbomb.h"

nbomb nbomb_create(point npos, float nspeed){

    nbomb l = { npos, sprite_create(16,16),0.0,nspeed,false};
    return l;

}

void nbomb_events(nbomb * l,bool reborn, ALLEGRO_SAMPLE * s){

    if(!l->dead){

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(l->gravity < 2.0)
            l->gravity += 0.1;

        sprite_animate(&l->spr,0,0,7,1);

    }
    else{

        if(l->spr.currentFrame != 5){
            sprite_animate(&l->spr,1,0,5,2);
        }
        else if(reborn){
            l->pos = newPoint(8 + rand() % 256 - 16,0 - (rand() % 640 + 160));
            l->speed = 0;
            l->gravity = 0.0;
            l->spr.scale_x = 1;
            l->dead = false;
            l->spr.currentFrame = 0;
        }
    }

    if(l->pos.y > 240-24 && !l->dead){

        al_play_sample(s,1.0,0.0,0.75,ALLEGRO_PLAYMODE_ONCE,NULL);
        l->gravity = 0.0;
        l->dead = true;
        l->spr.currentFrame = 0;
    }

}

void nbomb_render(nbomb * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -8 && l->pos.x < 256+8 ){

        if(l->pos.y < 240-16 && !(l->dead && l->spr.currentFrame == 5) && l->pos.y > -16){
            al_draw_filled_ellipse(l->pos.x,240-16,8 - (240-16 - l->pos.y)/75,3 - (240-16 - l->pos.y)/150,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-8,l->pos.y-8,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+8,l->pos.y-8,bmp);
        }

    }

}

void nbomb_bulletCollision(nbomb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(b->pos.x+2 > l->pos.x-8 && b->pos.x-2 < l->pos.x+8 && b->pos.y+2 > l->pos.y-8 && b->pos.y-2 < l->pos.y+8 && b->exist && !l->dead){
        l->gravity = 0.0;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        l->dead = true;
        l->spr.currentFrame = 0;
        *score += 200 * (*multiplier + 1);
        *multiplier += 1;
        *multiplier_timer = 60;
    }

}

void nbomb_playerCollision(nbomb * l, objPlayer * pl, int * lives){

    if(pl->pos.x+4 > l->pos.x-8 && pl->pos.x-4 < l->pos.x+8 && pl->pos.y+4 > l->pos.y-8 && pl->pos.y-4 < l->pos.y+8 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }
}
