#ifndef __NC_NBOMB__
#define __NC_NBOMB__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}nbomb;

nbomb nbomb_create(point npos, float nspeed);
void nbomb_events(nbomb * l, bool reborn, ALLEGRO_SAMPLE * s);
void nbomb_render(nbomb * l,ALLEGRO_BITMAP*bmp);
void nbomb_bulletCollision(nbomb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void nbomb_playerCollision(nbomb * l, objPlayer * pl, int * lives);

#endif // __NC_NBOMB__
