#include "orb.h"

orb orb_create(point npos, float nspeed){

    orb l = { npos, sprite_create(16,16),0.0,nspeed,false};
    return l;

}

void orb_events(orb * l,bool reborn){

    if(!l->dead){

        if(l->speed > 0 && l->pos.x > 256){
            l->speed = -fabs(l->speed);
        }

        if(l->speed < 0 && l->pos.x < 0){
            l->speed = fabs(l->speed);
        }

        l->pos.x += l->speed;
        l->pos.y += l->gravity;

        if(l->speed > 0){
            l->spr.scale_x = 1;
        }
        else{
            l->spr.scale_x = -1;
        }

        l->gravity += 0.25;
        if(l->pos.y > 240-24){
            l->gravity = -(float)(rand() % 750 + 100)/100.0;
        }

        sprite_animate(&l->spr,0,0,3,2);

    }
    else{

        l->gravity += 0.25;
        l->pos.y += l->gravity;

        sprite_animate(&l->spr,1,0,0,1);
    }
    if(reborn && l->pos.y > 240+8){

        int r = rand() % 2 + 1;

        if(r == 2){

                l->pos = newPoint(0 - rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2500 + 1500)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = 1;
                l->dead = false;

        }else{

                l->pos = newPoint(256 + rand() % 640,32+rand() % 240-64);
                l->speed = (float)(rand() % 2500 + 1500)/1000;
                l->gravity = 0.0;
                l->spr.scale_x = -1;
                l->dead = false;
        }

    }

}

void orb_render(orb * l,ALLEGRO_BITMAP*bmp){

    if(l->pos.x > -8 && l->pos.x < 256+8){

        if(l->pos.y < 240-16){
            al_draw_filled_ellipse(l->pos.x,240-16,8 - (240-16 - l->pos.y)/75,3 - (240-16 - l->pos.y)/150,al_map_rgb(0,0,0));
        }

        if(l->spr.scale_x == 1){
            sprite_render(&l->spr,l->pos.x-8,l->pos.y-8,bmp);
        }
        else{
            sprite_render(&l->spr,l->pos.x+8,l->pos.y-8,bmp);
        }

    }

}

void orb_bulletCollision(orb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer){

    if(b->pos.x+2 > l->pos.x-8 && b->pos.x-2 < l->pos.x+8 && b->pos.y+2 > l->pos.y-8 && b->pos.y-2 < l->pos.y+8 && b->exist && !l->dead){
        l->gravity = 0.0;
        b->exist = false;
        b->deathTimer = 2 + b->spr.frame_w;
        l->dead = true;
        *score += 250 * (*multiplier + 1);
        *multiplier += 1;
        *multiplier_timer = 60;
    }

}

void orb_playerCollision(orb * l, objPlayer * pl, int * lives){

    if(pl->pos.x+4 > l->pos.x-8 && pl->pos.x-4 < l->pos.x+8 && pl->pos.y+4 > l->pos.y-8 && pl->pos.y-4 < l->pos.y+8 && !pl->hurt && !l->dead){
        pl->hurt = true;
        pl->hurtTimer = 60;

        if(*lives > 0){
            (*lives)--;
        }
    }
}
