#ifndef __NC_ORB__
#define __NC_ORB__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}orb;

orb orb_create(point npos, float nspeed);
void orb_events(orb * l, bool reborn);
void orb_render(orb * l,ALLEGRO_BITMAP*bmp);
void orb_bulletCollision(orb * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void orb_playerCollision(orb * l, objPlayer * pl, int * lives);

#endif // __NC_ORB__
