#ifndef __NC_SLIME__
#define __NC_SLIME__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>

#include "../player/player.h"
#include "../sprite/sprite.h"
#include "../point/point.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr;

    float gravity,
          speed;

    bool dead;

}slime;

slime slime_create(point npos, float nspeed);
void slime_events(slime * l, bool reborn);
void slime_render(slime * l,ALLEGRO_BITMAP*bmp);
void slime_bulletCollision(slime * l, bullet * b, long int * score, int * multiplier, int * multiplier_timer);
void slime_playerCollision(slime * l, objPlayer * pl, int * lives);

#endif // __NC_SLIME__
