#include "player.h"

objPlayer player_newPlayer(point npos){

    objPlayer p;
    p.pos = npos;
    p.spr_main = sprite_create(16,16);
    p.spr_propeller = sprite_create(16,16);
    p.gravity = 0.0;
    p.throwing = false;
    p.boost = false;
    p.boostTimer = 0;
    p.hurt = false;
    p.hurtTimer = 0;
    p.speed = 0;
    p.dead = false;

    return p;
}

void player_render(objPlayer * pl, ALLEGRO_BITMAP * bmp){

    if(pl->pos.y <= 240-23)
        al_draw_filled_ellipse(pl->pos.x,240-16,8 - (240-16 - pl->pos.y)/75,3 - (240-16 - pl->pos.y)/150,al_map_rgb(0,0,0));

    if(pl->hurt == false || pl->hurtTimer % 2 == 0)
    {

        if(pl->spr_main.scale_x == 1){

            if(!pl->dead)
                sprite_render(&pl->spr_propeller,pl->pos.x-4,pl->pos.y-18,bmp);

            sprite_render(&pl->spr_main,pl->pos.x-8,pl->pos.y-8,bmp);
        }
        else{

            if(!pl->dead)
                sprite_render(&pl->spr_propeller,pl->pos.x+4,pl->pos.y-18,bmp);

            sprite_render(&pl->spr_main,pl->pos.x+8,pl->pos.y-8,bmp);
        }

    }

}

void player_kbdown(objPlayer * pl, int key,bullet * bullets,int * current_bullet, int stage, ALLEGRO_SAMPLE * s1, ALLEGRO_SAMPLE * s2){

    if(!pl->dead){

        switch(key){

        case ALLEGRO_KEY_Z:
            if(!pl->throwing){

                al_play_sample(s1,1.0,0.0,1.0,ALLEGRO_PLAYMODE_ONCE,NULL);

                pl->throwing = true;
                pl->spr_main.currentFrame = 0;

                bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(-pl->spr_main.scale_x * 4 + pl->speed,-2),8);
                *current_bullet += 1;
                if(*current_bullet > 49){
                    *current_bullet = 0;
                }

                if(stage > 1){

                    bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(-pl->spr_main.scale_x * 4 + pl->speed,-2),8);
                    bullets[*current_bullet].speed.y -= 1.0;

                    *current_bullet += 1;
                    if(*current_bullet > 49){
                        *current_bullet = 0;
                    }

                }

                if(stage > 3){

                    bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(-pl->spr_main.scale_x * 4 + pl->speed,-2),8);
                    bullets[*current_bullet].speed.y -= 2.0;

                    *current_bullet += 1;
                    if(*current_bullet > 49){
                        *current_bullet = 0;
                    }

                }

            }
            break;

        case ALLEGRO_KEY_X:

            if(!pl->throwing){

                al_play_sample(s2,1.0,0.0,1.0,ALLEGRO_PLAYMODE_ONCE,NULL);

                if(stage < 3){

                    pl->throwing = true;
                    pl->spr_main.currentFrame = 0;
                    bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(0,0),12);
                    *current_bullet += 1;
                    if(*current_bullet > 19){
                        *current_bullet = 0;
                    }

                }else{

                        pl->throwing = true;
                        pl->spr_main.currentFrame = 0;

                        bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(0,0),12);
                        *current_bullet += 1;
                        if(*current_bullet > 19){
                            *current_bullet = 0;
                        }

                        bullets[*current_bullet] = bullet_create(newPoint(pl->pos.x,pl->pos.y+4),newPoint(0,0),12);
                        bullets[*current_bullet].speed.y = -1.5;
                        *current_bullet += 1;
                        if(*current_bullet > 19){
                            *current_bullet = 0;
                        }

                }

            }

            break;

        default:
            break;

        }

    }

}

void player_events(objPlayer * pl,bool * keymap,boostEffect * effects,int current_boost, ALLEGRO_SAMPLE * s1, ALLEGRO_SAMPLE * s2){

    if(!pl->dead){

        if(pl->hurtTimer > 0 && pl->hurt){

            if(pl->hurtTimer == 60){
                al_play_sample(s2,1.75,0.0,1.0,ALLEGRO_PLAYMODE_ONCE,NULL);
            }

            pl->hurtTimer--;
        }
        else{
            pl->hurt = false;
        }

        if(pl->boostTimer > 0){
            pl->boostTimer--;
        }

        sprite_animate(&pl->spr_propeller,1,0,3,2 - (int)fabs(pl->gravity)/2);

        if(pl->throwing){
            sprite_animate(&pl->spr_main,0,0,2,3);
            if(pl->spr_main.currentFrame == 2){
                pl->throwing = false;
            }
        }
        else{
            sprite_animate(&pl->spr_main,0,2,2,1);
        }
        if(keymap[ALLEGRO_KEY_LEFT]){
            pl->spr_main.scale_x = 1;
            pl->spr_propeller.scale_x = 1;
            pl->pos.x -= 2;
            pl->speed = -2;
        }
        else if(keymap[ALLEGRO_KEY_RIGHT]){
            pl->spr_main.scale_x = -1;
            pl->spr_propeller.scale_x = -1;
            pl->pos.x += 2;
            pl->speed = 2;
        }

        if(!keymap[ALLEGRO_KEY_LEFT] && pl->speed == -2){
            pl->speed = 0;
        }

        if(!keymap[ALLEGRO_KEY_RIGHT] && pl->speed == 2){
            pl->speed = 0;
        }

        if(keymap[ALLEGRO_KEY_UP]){
            pl->gravity -= 0.15;
            pl->boost = true;
        }
        else if(keymap[ALLEGRO_KEY_DOWN]){
            pl->gravity += 0.08;
            pl->boost = true;
        }
        else{
            pl->boost = false;
        }

        if(pl->boost && pl->boostTimer <= 0){

            al_play_sample(s1,1.0,0.0,1.0,ALLEGRO_PLAYMODE_ONCE,NULL);
            pl->boostTimer = 3;
            effects[current_boost] = boostEffect_create(newPoint(pl->pos.x,pl->pos.y+4),30);
        }

        if(pl->pos.y > 240-24){
            pl->pos.y = 240-24;

            if(pl->gravity > 0.0)
                pl->gravity *= -0.25;
        }
        else if(pl->pos.y < 18){
            pl->pos.y = 18;
            pl->gravity = 0.0;
        }

        if(pl->pos.x < 0){
            pl->pos.x = 0;
        }
        else if(pl->pos.x > 255){
            pl->pos.x = 255;
        }

    }
    else{
        pl->boost = false;
        pl->hurt = false;
        pl->hurtTimer = 0;
        pl->throwing = false;
        sprite_animate(&pl->spr_main,2,0,3,2);
    }


    if(pl->gravity < 8.0){
        pl->gravity += 0.04;
    }

    pl->pos.y += pl->gravity;

}
