#ifndef __NC_PLAYER_H__
#define __NC_PLAYER_H__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <allegro5/allegro.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_native_dialog.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>

#include "../sprite/sprite.h"
#include "../point/point.h"
#include "boost.h"
#include "../bullet/bullet.h"

typedef struct{

    point pos;

    sprite spr_main,
           spr_propeller;

    float gravity,
          speed;

    bool throwing,
         boost,
         hurt,
         dead;

    int boostTimer,
        hurtTimer;

}objPlayer;

objPlayer player_newPlayer(point npos);
void player_kbdown(objPlayer * pl, int key,bullet * bullets,int * current_bullet, int stage, ALLEGRO_SAMPLE * s1, ALLEGRO_SAMPLE * s2);
void player_kbup(objPlayer * pl, int key);
void player_events(objPlayer * pl,bool * keymap,boostEffect * effects,int current_boost, ALLEGRO_SAMPLE * s1, ALLEGRO_SAMPLE * s2);
void player_render(objPlayer * pl,ALLEGRO_BITMAP*bmp);

#endif // __NC_PLAYER_H__
