#include "sprite.h"

void sprite_animate(sprite * spr,int row, int begin, int end, int speed){

    if(spr->currentRow != row)
        spr->currentRow = row;

    if(spr->currentFrame < begin)
    {
        spr->currentFrame = begin;
    }

    spr->changeFrameCount++;

    if(spr->changeFrameCount > speed)
    {
        spr->currentFrame++;
        if(spr->currentFrame > end)
        {
            spr->currentFrame = begin;
        }

        spr->changeFrameCount = 0;
    }

}

void sprite_render(sprite * spr,int tx, int ty, ALLEGRO_BITMAP * bmp){

    al_draw_scaled_bitmap(bmp,
                          spr->currentFrame * spr->frame_w,spr->currentRow*spr->frame_h,
                          spr->frame_w,spr->frame_h,
                          tx,ty,spr->frame_w * spr->scale_x,spr->frame_h * spr->scale_y, 0);

}

sprite sprite_create(int w, int h){

    sprite s;

    s.frame_w = w;
    s.frame_h = h;

    s.scale_x = 1;
    s.scale_y = 1;

    s.currentFrame = 0;
    s.currentRow = 0;
    s.changeFrameCount = 0;

    return s;

}
