static unsigned char enemyType[MAX_ENEMIES];
static unsigned char enemyVar[MAX_ENEMIES];
static unsigned char enemyVar2[MAX_ENEMIES];
static int enemyX[MAX_ENEMIES];
static int enemyY[MAX_ENEMIES];
static unsigned char enemyStun[MAX_ENEMIES];
static unsigned char enemyHealth[MAX_ENEMIES];

void __fastcall__ rotnipUpdate(void)
{
	if (enemyStun[i]) 
	{ 
		--enemyStun[i]; 
		x = (enemyX[i] / SUB_PIXELS) - scrollX;
		y = (enemyY[i] / SUB_PIXELS) - scrollY;
		t1 = (enemyX[i] / SUB_PIXELS) - scrollX < 255;
		if (t1)
		{
			if (enemyVar[i] % 16 < 8)
			{
				t0 = oam_spr(x - 8, y - 16, 0x32, 2, t0);
				t0 = oam_spr(x + 0, y - 16, 0x33, 2, t0);
				t0 = oam_spr(x - 8, y -  8, 0x42, 2, t0);
				t0 = oam_spr(x + 0, y -  8, 0x43, 2, t0);
			}
			else
			{
				t0 = oam_spr(x - 8, y - 16, 0x34, 2, t0);
				t0 = oam_spr(x + 0, y - 16, 0x35, 2, t0);
				t0 = oam_spr(x - 8, y -  8, 0x44, 2, t0);
				t0 = oam_spr(x + 0, y -  8, 0x45, 2, t0);
			}
		}
		return;
	}

	// update logic
	++enemyVar[i];
	x = (enemyX[i] / SUB_PIXELS) - scrollX;
	y = (enemyY[i] / SUB_PIXELS) - scrollY;
	t1 = (enemyX[i] / SUB_PIXELS) - scrollX < 255;
	if (enemyVar[i] < 16)
	{
		t2 = y - 16 + (8 - enemyVar[i] / 2);
		if (t1)
		{
			if ((enemyVar[i] % 8) < 4)
			{
				t0 = oam_spr(x - 8, t2 + 0, 0x3A, 2, t0);
				t0 = oam_spr(x + 0, t2 + 0, 0x3B, 2, t0);
				if (enemyVar[i] > 7)
				{
					t0 = oam_spr(x - 8, t2 + 8, 0x4A, 2, t0);
					t0 = oam_spr(x + 0, t2 + 8, 0x4B, 2, t0);
				}
			}
			else
			{
				t0 = oam_spr(x - 8, t2 + 0, 0x3C, 2, t0);
				t0 = oam_spr(x + 0, t2 + 0, 0x3D, 2, t0);
				if (enemyVar[i] > 7)
				{
					t0 = oam_spr(x - 8, t2 + 8, 0x4C, 2, t0);
					t0 = oam_spr(x + 0, t2 + 8, 0x4D, 2, t0);
				}
			}
		}
	}
	else if (enemyVar[i] < 100)
	{
		enemyX[i] -= 3;
		
		if (t1)
		{
			#define hitboxSize 14 * SUB_PIXELS
			#define hurtboxSize 9 * SUB_PIXELS
			
			// rotnip -> player collision
			if (!invincible)
			{
				if (abs(playerWorldX - enemyX[i]) < hitboxSize &&
					abs(playerWorldY - enemyY[i]) < hitboxSize)
				{
					hurt(2);
				}
			}
			
			// player -> rotnip collision
			if (attacking)
			{
				if (abs(attackY - enemyY[i]) < hurtboxSize * 2)
				{
					ti1 = 8;
					t3 = attacking / 3;
					if (weaponLevel < t3)
						ti1 += weaponLevel * 8;
					else
						ti1 += t3 * 9;
					if (playerFlags & FACING_RIGHT)
					{
						if (enemyX[i] - attackX < (ti1 * SUB_PIXELS + hurtboxSize))
						{
							sfx_play(1, 2);
							if (--enemyHealth[i] == 0)
							{
								enemyType[i] = 0;
								t1 = 0;
							}
							else
							{
								enemyStun[i] = 24;
							}
						}
					}
					else
					{
						if (attackX - enemyX[i] < (ti1 * SUB_PIXELS + hurtboxSize))
						{
							sfx_play(1, 2);
							if (--enemyHealth[i] == 0)
							{
								enemyType[i] = 0;
								t1 = 0;
							}
							else
							{
								enemyStun[i] = 24;
							}
						}
					}
				}
			}
			
			#undef hurtboxSize
			#undef hitboxSize
		}
		
		if (t1)
		{
			if (enemyVar[i] % 16 < 8)
			{
				t0 = oam_spr(x - 8, y - 16, 0x32, 2, t0);
				t0 = oam_spr(x + 0, y - 16, 0x33, 2, t0);
				t0 = oam_spr(x - 8, y -  8, 0x42, 2, t0);
				t0 = oam_spr(x + 0, y -  8, 0x43, 2, t0);
			}
			else
			{
				t0 = oam_spr(x - 8, y - 16, 0x34, 2, t0);
				t0 = oam_spr(x + 0, y - 16, 0x35, 2, t0);
				t0 = oam_spr(x - 8, y -  8, 0x44, 2, t0);
				t0 = oam_spr(x + 0, y -  8, 0x45, 2, t0);
			}
		}
	}
	else if (enemyVar[i] < 116)
	{
		if (t1)
		{
			t2 = y - 16 + (enemyVar[i] - 100) / 2;
			if ((enemyVar[i] % 8) < 4)
			{
				t0 = oam_spr(x - 8, t2 + 0, 0x36, 2, t0);
				t0 = oam_spr(x + 0, t2 + 0, 0x37, 2, t0);
				if (enemyVar[i] < 108)
				{
					t0 = oam_spr(x - 8, t2 + 8, 0x46, 2, t0);
					t0 = oam_spr(x + 0, t2 + 8, 0x47, 2, t0);
				}
				else
				{
					hideSpr(hideSpr(t0));
				}
			}
			else
			{
				t0 = oam_spr(x - 8, t2 + 0, 0x38, 2, t0);
				t0 = oam_spr(x + 0, t2 + 0, 0x39, 2, t0);
				if (enemyVar[i] < 108)
				{
					t0 = oam_spr(x - 8, t2 + 8, 0x48, 2, t0);
					t0 = oam_spr(x + 0, t2 + 8, 0x49, 2, t0);
				}
				else
				{
					t0 = hideSpr(hideSpr(t0));
				}
			}
		}
	}
	else if (enemyVar[i] < 230)
	{
		t1 = 0;
	}
	else
	{
		enemyVar[i] = 0;
		enemyX[i] += 252;
	}
	
	if (!t1)
	{
		t0 = hideSpr(hideSpr(hideSpr(hideSpr(t0))));
	}
}

void __fastcall__ flopflopUpdate(void)
{
	// respawn time
	if (enemyVar[i] >= 128)
	{
		if (++enemyVar[i] == 0xFF)
		{
			enemyVar[i] = 0;
			enemyX[i] = 64 * 8 * SUB_PIXELS;
		}
		else
		{
			t0 = hideSpr(hideSpr(hideSpr(hideSpr(t0))));
			return;
		}	
	}

	// update
	if (enemyX[i] <= 3)
	{
		enemyX[i] = 64 * 8 * SUB_PIXELS;
	}
	else
	{
		enemyX[i] -= 4;
	}
	if (++enemyVar[i] == 64) enemyVar[i] = 0;
	if (enemyVar[i] < 32)
	{
		enemyY[i] += 3;
	}
	else if (enemyVar[i] < 64)
	{
		enemyY[i] -= 3;
	}
	
	x = (enemyX[i] / SUB_PIXELS) - scrollX;
	y = (enemyY[i] / SUB_PIXELS) - scrollY;
	t1 = (enemyX[i] / SUB_PIXELS) - scrollX < 255;
	
	// collision
	if (t1)
	{
		#define hitboxSize 14 * SUB_PIXELS
		#define hurtboxSize 9 * SUB_PIXELS
		
		// flopflop -> player collision
		if (!invincible)
		{
			if (abs(playerWorldX - enemyX[i]) < hitboxSize &&
				abs(playerWorldY - enemyY[i]) < hitboxSize)
			{
				hurt(3);
			}
		}
		
		// player -> flopflop collision
		if (attacking)
		{
			if (abs(attackY - enemyY[i]) < (hurtboxSize * 2))
			{
				ti1 = 8;
				t3 = attacking / 3;
				if (weaponLevel < t3)
					ti1 += weaponLevel * 8;
				else
					ti1 += t3 * 9;
				if (playerFlags & FACING_RIGHT)
				{
					if (enemyX[i] - attackX < (ti1 * SUB_PIXELS + hurtboxSize))
					{
						sfx_play(1, 2);
						enemyVar[i] = 128;
						t1 = 0;
					}
				}
				else
				{
					if (attackX - enemyX[i] < (ti1 * SUB_PIXELS + hurtboxSize))
					{
						sfx_play(1, 2);
						enemyVar[i] = 128;
						t1 = 0;
					}
				}
			}
		}
		
		#undef hurtboxSize
		#undef hitboxSize
	}
	
	// draw
	if (t1)
	{
		t2 = (enemyVar[i] % 16);
		if (t2 < 4)
		{
			t0 = oam_spr(x - 8, y - 16, 0x50, 2, t0);
			t0 = oam_spr(x + 0, y - 16, 0x51, 2, t0);
			t0 = oam_spr(x - 8, y - 8, 0x60, 2, t0);
			t0 = oam_spr(x + 0, y - 8, 0x61, 2, t0);
		}
		else if (t2 < 8)
		{
			t0 = oam_spr(x - 8, y - 16, 0x52, 2, t0);
			t0 = oam_spr(x + 0, y - 16, 0x53, 2, t0);
			t0 = oam_spr(x - 8, y - 8, 0x62, 2, t0);
			t0 = oam_spr(x + 0, y - 8, 0x63, 2, t0);
		}
		else if (t2 < 12)
		{
			t0 = oam_spr(x - 8, y - 16, 0x54, 2, t0);
			t0 = oam_spr(x + 0, y - 16, 0x55, 2, t0);
			t0 = oam_spr(x - 8, y - 8, 0x64, 2, t0);
			t0 = oam_spr(x + 0, y - 8, 0x65, 2, t0);
		}
		else
		{
			t0 = oam_spr(x - 8, y - 16, 0x52, 2, t0);
			t0 = oam_spr(x + 0, y - 16, 0x53, 2, t0);
			t0 = oam_spr(x - 8, y - 8, 0x62, 2, t0);
			t0 = oam_spr(x + 0, y - 8, 0x63, 2, t0);
		}
	}
	else
	{
		t0 = hideSpr(hideSpr(hideSpr(hideSpr(t0))));
	}
}

void __fastcall__ fishbunUpdate(void)
{
	if (++enemyVar[i] == 128)
	{
		enemyVar[i] = 0;
		if (++enemyVar2[i] == 4)
			enemyVar2[i] = 0;
	}
	if (enemyVar[i] < 64)
	{
		if (enemyVar2[i] < 2)
		{
			enemyX[i] -= 2;
		}
		else
		{
			enemyX[i] += 2;
		}
	}
	else if (enemyVar[i] < 128)
	{
	}
	
	x = (enemyX[i] / SUB_PIXELS) - scrollX;
	y = (enemyY[i] / SUB_PIXELS) - scrollY;
	t1 = (enemyX[i] / SUB_PIXELS) - scrollX < 255;
	
	// collision
	if (t1)
	{
		#define hitboxSize 14 * SUB_PIXELS
		#define hurtboxSize 9 * SUB_PIXELS
		
		// fishbun -> player collision
		if (!invincible)
		{
			if (abs(playerWorldX - enemyX[i]) < hitboxSize &&
				abs(playerWorldY - enemyY[i]) < hitboxSize)
			{
				hurt(1);
			}
		}
		
		// player -> fishbun collision
		if (attacking)
		{
			if (abs(attackY - enemyY[i]) < hurtboxSize * 2)
			{
				ti1 = 8;
				t3 = attacking / 3;
				if (weaponLevel < t3)
					ti1 += weaponLevel * 8;
				else
					ti1 += t3 * 9;
				if (playerFlags & FACING_RIGHT)
				{
					if (enemyX[i] - attackX < (ti1 * SUB_PIXELS + hurtboxSize))
					{
						sfx_play(1, 2);
						if (--enemyHealth[i] == 0)
						{
							enemyType[i] = 0;
							t1 = 0;
						}
						else
						{
							enemyStun[i] = 16;
						}
					}
				}
				else
				{
					if (attackX - enemyX[i] < (ti1 * SUB_PIXELS + hurtboxSize))
					{
						sfx_play(1, 2);
						if (--enemyHealth[i] == 0)
						{
							enemyType[i] = 0;
							t1 = 0;
						}
						else
						{
							enemyStun[i] = 16;
						}
					}
				}
			}
		}
		
		#undef hurtboxSize
		#undef hitboxSize
	}
	
	// draw
	if (t1)
	{
		if (enemyVar[i] < 64)
		{
			if ((enemyVar[i] % 16) < 8)
			{
				if (enemyVar2[i] < 2)
				{
					t0 = oam_spr(x - 8, y - 16, 0x72, 3, t0);
					t0 = oam_spr(x + 0, y - 16, 0x73, 3, t0);
					t0 = oam_spr(x - 8, y - 8, 0x82, 3, t0);
					t0 = oam_spr(x + 0, y - 8, 0x83, 3, t0);
				}
				else
				{
					t0 = oam_spr(x - 8, y - 16, 0x73, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x + 0, y - 16, 0x72, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x - 8, y - 8, 0x83, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x + 0, y - 8, 0x82, 3 | OAM_FLIP_H, t0);
				}
			}
			else
			{
				if (enemyVar2[i] < 2)
				{
					t0 = oam_spr(x - 8, y - 16, 0x74, 3, t0);
					t0 = oam_spr(x + 0, y - 16, 0x75, 3, t0);
					t0 = oam_spr(x - 8, y - 8, 0x84, 3, t0);
					t0 = oam_spr(x + 0, y - 8, 0x85, 3, t0);
				}
				else
				{
					t0 = oam_spr(x - 8, y - 16, 0x75, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x + 0, y - 16, 0x74, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x - 8, y - 8, 0x85, 3 | OAM_FLIP_H, t0);
					t0 = oam_spr(x + 0, y - 8, 0x84, 3 | OAM_FLIP_H, t0);
				}
			}
		}
		else
		{
			if (enemyVar2[i] < 2)
			{
				t0 = oam_spr(x - 8, y - 16, 0x70, 3, t0);
				t0 = oam_spr(x + 0, y - 16, 0x71, 3, t0);
				t0 = oam_spr(x - 8, y - 8, 0x80, 3, t0);
				t0 = oam_spr(x + 0, y - 8, 0x81, 3, t0);
			}
			else
			{
				t0 = oam_spr(x - 8, y - 16, 0x71, 3 | OAM_FLIP_H, t0);
				t0 = oam_spr(x + 0, y - 16, 0x70, 3 | OAM_FLIP_H, t0);
				t0 = oam_spr(x - 8, y - 8, 0x81, 3 | OAM_FLIP_H, t0);
				t0 = oam_spr(x + 0, y - 8, 0x80, 3 | OAM_FLIP_H, t0);
			}
		}
	}
	else
	{
		t0 = hideSpr(hideSpr(hideSpr(hideSpr(t0))));
	}
}

void __fastcall__ enemiesUpdate(void)
{
	for (i = 0; i < MAX_ENEMIES; ++i)
	{
		t0 = (0 + (i * 4)) * 4;
		switch (enemyType[i])
		{
			case ROTNIP: rotnipUpdate(); break;
			case FLOPFLOP: flopflopUpdate(); break;
			case FISHBUN: fishbunUpdate(); break;
			default: break;
		}
	}
}