#include "neslib.h"

// nametables

#include "nametables/nam_title.h"

#include "nametables/nam_level0a_green.h"
#include "nametables/nam_level0b_green.h"
#include "nametables/nam_level0c_green.h"

#include "nametables/nam_level1a_generic.h"
#include "nametables/nam_level1b_generic.h"
#include "nametables/nam_level1c_generic.h"
#include "nametables/level1d_red.h"
#include "nametables/level1e_red.h"

#include "nametables/nam_empty.h"
#include "nametables/nam_generic_midroom.h"
#include "nametables/nam_generic_starter1.h"
#include "nametables/nam_generic_ender1.h"
#include "nametables/nam_generic_ender2.h"

#include "nametables/level2a_castle.h"
#include "nametables/level2b_castle.h"
#include "nametables/level2c_castle.h"
#include "nametables/level2d_castle.h"
#include "nametables/level2e_castle.h"
#include "nametables/level2f_castle.h"
#include "nametables/level2g_castle.h"

// palettes
#include "palettes/pal_greenforest.h"
#include "palettes/pal_redforest.h"
#include "palettes/pal_sprites_greenforest.h"
#include "palettes/pal_title.h"
#include "palettes/pal_castle.h"

// data
#include "rooms.h"

//#define DEBUG

// music
extern const unsigned char const music_stage1[];
extern const unsigned char const music_stage2[];
extern const unsigned char const music_stage3[];

#define SUB_PIXELS 8
#define TILE_IN_SUB_PIXELS (SUB_PIXELS * 8)
#define MAX_ENEMIES 3

static unsigned char i, j, r, t0, t1, t2, t3, t4, t5;
//static char ts0, ts1;
//static unsigned char *p1;
static const unsigned char *cp1;
//static const void * cvp1;
static unsigned char x, y; //x2, y2;
static unsigned int ti1;
#define roll(x) (rand8() < x)
#define randmod(x) (rand8() % x)
#define null NULL
#define nametableAddr(x, y) ((0x2000,((y)<<5),x))
const unsigned char * frameCounterPtr = 0x0000;
#define frameCounter *frameCounterPtr
const unsigned char startupDebugValue = 1;

static unsigned char gamepad;

const unsigned char scrollY = 8;
static unsigned char scrollX = 0;
static unsigned char hasKey = 0;
static unsigned char gameState = 0;

static unsigned char vramupdate[] =
{
	0x00, 0x00, 0x00,
	0x00, 0x00, 0x00,
	0x00, 0x00, 0x00,
	0x00, 0x00, 0x00,
};

enum ENEMY_TYPES
{
	ROTNIP = 1,
	FLOPFLOP,
	FISHBUN,
};

#include "utility.h"
#include "level.h"
#include "player.h"
#include "hud.h"
#include "enemies.h"