// data for all levels/rooms

#define VARS_PER_DOORMAP_ENTRY 5

const unsigned char greenDoorsRoom01[] = // nam_level0b_green
{
	2, // num doors
	60, 23, 1, 5, 23, // in-x, in-y, destination, out-x, out-y
	45, 25, 0xFF, 0, 0,
};

const unsigned char greenDoorsRoom02[] =
{
	2,
	5, 23, 0, 60, 23,
	24, 23, 2, 2, 23
};

const unsigned char greenDoorsRoom03[] =
{
	2,
	2, 23, 1, 24, 23,
	60, 23, 3, 5, 23,
};

const unsigned char greenDoorsRoom04[] =
{
	2,
	5, 23, 2, 60, 23,
	24, 23, 4, 2, 23,
};

const unsigned char greenDoorsRoom05[] =
{
	2,
	2, 23, 3, 24, 23,
	55, 15, 5, 5, 23,
};

const unsigned char greenDoorsRoom06[] =
{
	1,
	5, 23, 4, 55, 15,
};

// each level has exactly 8 rooms
const unsigned char * const roomsLevel1[] =
{ // nametable 1, nametable 2, doormap 
	nam_level0a_green, nam_level0b_green, greenDoorsRoom01,
	nam_generic_midroom, nam_empty, greenDoorsRoom02,
	nam_generic_starter1, nam_generic_ender2, greenDoorsRoom03,
	nam_generic_midroom, nam_empty, greenDoorsRoom04,
	nam_generic_starter1, nam_generic_ender1, greenDoorsRoom05,
	nam_level0c_green, nam_empty, greenDoorsRoom06,
};

const unsigned char redDoorsRoom01[] = // nam_level0b_green
{
	1, // num doors
	60, 21, 1, 5, 23, // in-x, in-y, destination, out-x, out-y
};

const unsigned char redDoorsRoom02[] =
{
	3,
	5, 23, 0, 60, 21,
	58, 14, 2, 5, 23,
	52, 23, 0xFF, 0, 0,
};

const unsigned char redDoorsRoom03[] =
{
	2,
	5, 23, 1, 58, 14,
	24, 23, 3, 5, 23,
};

const unsigned char redDoorsRoom04[] =
{
	2,
	5, 23, 2, 24, 23,
	24, 23, 4, 2, 23,
};

const unsigned char redDoorsRoom05[] =
{
	2,
	2, 23, 3, 24, 23,
	60, 21, 5, 5, 23,
};

const unsigned char redDoorsRoom06[] =
{
	1,
	5, 23, 4, 60, 21,
};

const unsigned char * const roomsLevel2[] =
{ // nametable 1, nametable 2, doormap 
	nam_level1a_generic, nam_level1b_generic, redDoorsRoom01,
	nam_level1c_generic, level1d_red, redDoorsRoom02,
	nam_generic_midroom, nam_empty, redDoorsRoom03,
	nam_generic_midroom, nam_empty, redDoorsRoom04,
	level1e_red, nam_level1b_generic, redDoorsRoom05,
	nam_level0c_green, nam_empty, redDoorsRoom06,
};

const unsigned char castleDoorsRoom01[] = // nam_level0b_green
{
	2, // num doors
	28, 23, 0xFF, 0, 0,
	58, 23, 1, 4, 23, // in-x, in-y, destination, out-x, out-y
};

const unsigned char castleDoorsRoom02[] =
{
	2,
	4, 23, 0, 58, 23,
	26, 23, 2, 4, 23,
};

const unsigned char castleDoorsRoom03[] =
{
	2,
	4, 23, 1, 26, 23,
	26, 23, 3, 4, 23,
};

const unsigned char castleDoorsRoom04[] =
{
	2,
	4, 23, 2, 26, 23,
	26, 23, 4, 8, 23,
};

const unsigned char castleDoorsRoom05[] =
{
	2,
	8, 23, 3, 26, 23,
};

const unsigned char * const roomsLevel3[] =
{ // nametable 1, nametable 2, doormap 
	level2a_castle, level2b_castle, castleDoorsRoom01,
	level2c_castle, nam_empty, castleDoorsRoom02,
	level2c_castle, nam_empty, castleDoorsRoom03,
	level2c_castle, nam_empty, castleDoorsRoom04,
	level2d_castle, level2e_castle, castleDoorsRoom05,
};

const unsigned char castleEnd[] =
{
	0,
};

const unsigned char * const roomsLevel4[] =
{ // nametable 1, nametable 2, doormap 
	level2f_castle, level2g_castle, castleEnd,
};

const unsigned char * const * levels[] =
{
	roomsLevel1,
	roomsLevel2,
	roomsLevel3,
	roomsLevel4,
};

const unsigned char spawnPoints[] =
{
	5, 23, // x, y
	5, 23,
	5, 23,
	8, 23,
};