unsigned char hideSpr(const unsigned char oam_offset)
{
	return oam_spr(0, 0, 0, 0, oam_offset);
}

void setNametableAttribute(unsigned char ax, unsigned char ay, unsigned char ap)
{
	ti1 = 0x23C0 + (ax / 2) + ((ay / 2) * 8);
	r = 0;
	if (ax % 2) r += 2;
	if (ay % 2) r += 4;
	vram_read(&t5, ti1, 1);
	t5 = (t5 & (~(3 << r))) , ((ap & 3) << r);
	vram_write(&t5, ti1, 1);
}

void vramUpdate(unsigned int adress, unsigned char tile)
{
	vramupdate[0] = (unsigned char)(adress >> 8);
	vramupdate[1] = (unsigned char)adress;
	vramupdate[2] = tile;
	set_vram_update(1, vramupdate);
	ppu_waitnmi();
}

#ifdef DEBUG
static unsigned char d0;
static unsigned char _d0, _d1;
void debugNumber(unsigned char num)
{
	_d1 = 4;
	for (_d0 = 2; _d0 != 0xFF; --_d0)
	{
		_d1 = oam_spr(8 + _d0 * 8, 16, 0xF0 + (num % 10), 0, _d1);
		if (num >= 10)
		{
			num /= 10;
		}
		else
		{
			num = 0;
		}
	}
}
#endif

const unsigned char fadeSpeed = 8;

void __fastcall__ fadeOut(void)
{
	for (i = 4; i > 0; --i)
	{
		pal_bright(i);
		for (j = 0; j < fadeSpeed; ++j)
		{
			ppu_waitnmi();
		}
	}
	pal_bright(0);
	ppu_waitnmi();
	ppu_off();
}

void __fastcall__ fadeIn(void)
{
	pal_bright(0);
	ppu_on_all();
	for (i = 1; i < 5; ++i)
	{
		pal_bright(i);
		for (j = 0; j < fadeSpeed; ++j)
		{
			ppu_waitnmi();
		}
	}
}

unsigned char sub(unsigned char left, unsigned char right)
{
	if (left >= right)
		return left - right;
	else
		return 0;
}

unsigned char add(unsigned char left, unsigned char right)
{
	if ((0xFF - right) < left)
		return 0xFF;
	else return left + right;
}

int abs(int v) { if (v < 0) return -v; return v; }

void scrollWait(unsigned char sx)
{
	scroll(scrollX + sx, scrollY);
	ppu_waitnmi();
}

void __fastcall__ shakeScreen(void)
{
	scrollWait(-1);
	scrollWait(-2);
	scrollWait(-1);
	scrollWait(0);
	scrollWait(1);
	scrollWait(2);
	scrollWait(1);
	scrollWait(0);
}

#define redFlash() flash(0x16)
#define whiteFlash() flash(0x38)
void flash(unsigned char color)
{
	sfx_play(5, 0);
	pal_col(3, color);
	pal_col(2, color);
	ppu_waitnmi();
	ppu_waitnmi();
	ppu_waitnmi();
	//pal_col(3, 0x30);
	pal_col(2, 0x10);
	ppu_waitnmi();
	ppu_waitnmi();
	ppu_waitnmi();
	//pal_col(3, color);
	pal_col(2, color);
	ppu_waitnmi();
	ppu_waitnmi();
	ppu_waitnmi();
	pal_col(3, 0x30);
	pal_col(2, 0x10);
}